﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

/*
* 共三种传图片方式，file,image_url,image_id必须选择其中的一个，
* 采用抓取网络图片方式时选取此参数,支持的文件类型包括：静态图片或图片压缩包(jpg, jpeg, bmp, png大小不超过10M，zip大小不超过50M)，url数组(数量不超过20)
* image_id时选取此参数，可在多个接口间共享，减少图片传输的带宽，支持的类型包括：image_id字符串或字符串数组(数量不超过20)
* 将图片二进制数据写入到HttpQuest body中，则不需要上传参数，否则需要上传image_url或image_id参数，body为空即可。
* 本示例采用将图片二进制数据写入到body中的方式
* 具体细节请参考官网接口文档：https://doc.xfyun.cn/rest_api/index.html
 */
namespace sexy_filter
{
    class Program
    {
        public static String Md5(string s)
        {
            System.Security.Cryptography.MD5 md5 = new System.Security.Cryptography.MD5CryptoServiceProvider();
            byte[] bytes = System.Text.Encoding.UTF8.GetBytes(s);
            bytes = md5.ComputeHash(bytes);
            md5.Clear();
            string ret = "";
            for (int i = 0; i < bytes.Length; i++)
            {
                ret += Convert.ToString(bytes[i], 16).PadLeft(2, '0');
            }
            return ret.PadLeft(32, '0');
        }

        public static void request()
        {
            string x_appid = "";
            string api_key = "";
            string path = "";

            //string param = "{}";

            System.Text.Encoding encode = System.Text.Encoding.ASCII;
            // byte[] bytedata = encode.GetBytes(param);
            //string x_param = Convert.ToBase64String(bytedata);

            TimeSpan ts = DateTime.UtcNow - new DateTime(1970, 1, 1, 0, 0, 0, 0);
            string curTime = Convert.ToInt64(ts.TotalSeconds).ToString();

            MD5CryptoServiceProvider md5 = new MD5CryptoServiceProvider();
            string result = string.Format("{0}{1}", api_key, curTime);
            string x_checksum = Program.Md5(result);

            byte[] arr = File.ReadAllBytes(path);
            string cc = Convert.ToBase64String(arr);
            string data = "file=" + cc;

            String Url = "http://api.xfyun.cn/v1/service/v1/image_identify/sexy_filter";
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(Url);
            request.Method = "POST";
            request.ContentType = "application/x-www-form-urlencoded";
            request.Headers["X-Appid"] = x_appid;
            request.Headers["X-CurTime"] = curTime;
            //request.Headers["X-Param"] = x_param;
            request.Headers["X-Checksum"] = x_checksum;

            request.ContentLength = Encoding.UTF8.GetByteCount(data);
            Stream requestStream = request.GetRequestStream();
            StreamWriter streamWriter = new StreamWriter(requestStream, Encoding.GetEncoding("gb2312"));
            streamWriter.Write(data);
            streamWriter.Close();

            string htmlStr = string.Empty;
            HttpWebResponse response = request.GetResponse() as HttpWebResponse;
            Stream responseStream = response.GetResponseStream();
            using (StreamReader reader = new StreamReader(responseStream, Encoding.GetEncoding("UTF-8")))
            {
                htmlStr = reader.ReadToEnd();
            }
            responseStream.Close();
            Console.WriteLine(htmlStr);
            Console.ReadLine();
        }

        static void Main(string[] args)
        {
            request();
        }
    }
}
